config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  root 'routines#index'
  resources :exercises
  resources :routines
  devise_for :users, controllers: { sessions: 'users/sessions' }
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Defines the root path route ("/")
  # root "articles#index"
end

app/models/application_record.rb
# frozen_string_literal: true

class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/exercise.rb
class Exercise < ApplicationRecord
  has_and_belongs_to_many :routines

  validates :description, presence: true
  validates :intensity, presence: true,
                        numericality: { only_integer: true, in: 0..10 }

  def description_with_intensity
    "#{description} - #{intensity}"
  end
end

app/models/routine.rb
class Routine < ApplicationRecord
  has_and_belongs_to_many :exercises
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # , :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable, :confirmable, :lockable

  def update_token!
    payload = { id:, timestamp: Time.now }
    update(jwt_key: JsonWebToken.encode(payload))
  end
end

app/controllers/application_controller.rb
# frozen_string_literal: true

class ApplicationController < ActionController::Base
  def verify_token
    JsonWebToken.decode(current_user.jwt_key)
    current_user.update_token!
  rescue JsonWebToken::ExpiredToken
    sign_out
    redirect_to new_user_session_path, alert: 'Token expired!'
  end
end

app/controllers/exercises_controller.rb
class ExercisesController < ApplicationController
  before_action :set_exercise, only: %i[show edit update destroy]
  before_action :authenticate_user!
  before_action :verify_token

  # GET /exercises
  def index
    @exercises = Exercise.all
  end

  # GET /exercises/1
  def show; end

  # GET /exercises/new
  def new
    @exercise = Exercise.new
  end

  # GET /exercises/1/edit
  def edit; end

  # POST /exercises
  def create
    @exercise = Exercise.new(exercise_params)

    if @exercise.save
      redirect_to exercise_url(@exercise), notice: 'Exercise was successfully created.'
    else
      render :new, status: :unprocessable_entity
    end
  end

  # PATCH/PUT /exercises/1
  def update
    if @exercise.update(exercise_params)
      redirect_to exercise_url(@exercise), notice: 'Exercise was successfully updated.'
    else
      render :edit, status: :unprocessable_entity
    end
  end

  # DELETE /exercises/1
  def destroy
    @exercise.destroy

    redirect_to exercises_url, notice: 'Exercise was successfully destroyed.'
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_exercise
    id = params[:id]
    @exercise = Exercise.find(params[:id])
  rescue ActiveRecord::RecordNotFound
    redirect_to exercises_path, alert: "Exercise with id '#{id}' not found!"
  end

  # Only allow a list of trusted parameters through.
  def exercise_params
    params.require(:exercise).permit(:description, :intensity)
  end
end

app/controllers/routines_controller.rb
class RoutinesController < ApplicationController
  before_action :set_routine, only: %i[show edit update destroy]
  before_action :authenticate_user!, except: %i[index show]
  before_action :verify_token, except: %i[index show]

  # GET /routines
  def index
    @routines = Routine.all
  end

  # GET /routines/1
  def show; end

  # GET /routines/new
  def new
    @routine = Routine.new
  end

  # GET /routines/1/edit
  def edit; end

  # POST /routines
  def create
    @routine = Routine.new(routine_params)
    if @routine.save
      redirect_to routine_url(@routine), notice: 'Routine was successfully created.'
    else
      render :new, status: :unprocessable_entity
    end
  end

  # PATCH/PUT /routines/1
  def update
    if @routine.update(routine_params)
      redirect_to routine_url(@routine), notice: 'Routine was successfully updated.'
    else
      render :edit, status: :unprocessable_entity
    end
  end

  # DELETE /routines/1
  def destroy
    @routine.destroy
    redirect_to routines_url, notice: 'Routine was successfully destroyed.'
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_routine
    id = params[:id]
    @routine = Routine.find(id)
  rescue ActiveRecord::RecordNotFound
    redirect_to routines_path, alert: "Routine with id '#{id}' not found!"
  end

  # Only allow a list of trusted parameters through.
  def routine_params
    params.require(:routine).permit(:name, exercise_ids: [])
  end
end

app/controllers/users/sessions_controller.rb
# frozen_string_literal: true

class Users::SessionsController < Devise::SessionsController
  # before_action :configure_sign_in_params, only: [:create]

  # GET /resource/sign_in
  # def new
  #   super
  # end

  # POST /users/sign_in
  def create
    super(&:update_token!)
  end

  # DELETE /resource/sign_out
  # def destroy
  #   super
  # end

  # protected

  # If you have extra params to permit, append them to the sanitizer.
  # def configure_sign_in_params
  #   devise_parameter_sanitizer.permit(:sign_in, keys: [:attribute])
  # end
end

app/helpers/application_helper.rb
# frozen_string_literal: true

module ApplicationHelper
end

app/views/exercises/_exercise.html.erb
<div id="<%= dom_id exercise %>">
  <p>
    <strong>Description:</strong>
    <%= exercise.description %>
  </p>

  <p>
    <strong>Intensity:</strong>
    <%= exercise.intensity %>
  </p>

</div>

app/views/exercises/_form.html.erb
<%= form_with(model: exercise) do |form| %>
  <% if exercise.errors.any? %>
    <div style="color: red">
      <p><%= pluralize(exercise.errors.count, "error") %> prohibited this exercise from being saved:</p>
      <ul>
        <% exercise.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div>
    <%= form.label :description, style: "display: block" %>
    <%= form.text_field :description %>
  </div>

  <div>
    <%= form.label :intensity, style: "display: block" %>
    <%= form.text_field :intensity %>
  </div>

  <div>
    <%= form.submit %>
  </div>
<% end %>

app/views/exercises/edit.html.erb
<h1>Editing exercise</h1>

<%= render "form", exercise: @exercise %>

<br>

<div>
  <%= link_to "Show this exercise", @exercise %> |
  <%= link_to "Back to exercises", exercises_path %>
</div>

app/views/exercises/index.html.erb
<h1>Exercises</h1>

<div id="exercises">
  <% @exercises.each do |exercise| %>
    <%= render exercise %>
    <p>
      <%= link_to "Show this exercise", exercise %>
    </p>
  <% end %>
</div>

<%= link_to "New exercise", new_exercise_path %>

app/views/exercises/new.html.erb
<h1>New exercise</h1>

<%= render "form", exercise: @exercise %>

<br>

<div>
  <%= link_to "Back to exercises", exercises_path %>
</div>

app/views/exercises/show.html.erb
<p style="color: green"><%= notice %></p>

<%= render @exercise %>

<div>
  <%= link_to "Edit this exercise", edit_exercise_path(@exercise) %> |
  <%= link_to "Back to exercises", exercises_path %>

  <%= button_to "Destroy this exercise", @exercise, method: :delete %>
</div>

app/views/layouts/_header.html.erb
<h1>Workout App</h1>
<% if user_signed_in? %>
<p></p>
  <%= link_to "Logged as #{current_user.email}", edit_user_registration_path(current_user) %>

  <%= button_to "Logout", destroy_user_session_path, method: :delete %>
<%else%>
  <%= link_to "Sign in", new_user_session_path %>
<%end%>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>WorkoutApp</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag "application", "data-turbo-track": "reload" %>
    <%= javascript_importmap_tags %>
  </head>

  <body>
    <%= render "layouts/header" %>
    <p style="color: green"><%= notice %></p>
    <p style="color: red"><%= alert %></p>
    <%= yield %>
  </body>
</html>

app/views/routines/_form.html.erb
<%= form_with(model: routine) do |form| %>
  <% if routine.errors.any? %>
    <div style="color: red">
      <h2><%= pluralize(routine.errors.count, "error") %> prohibited this routine from being saved:</h2>
      <ul>
        <% routine.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>
  <div>
    <%= form.label :name, style: "display: block" %>
    <%= form.text_field :name %>
  </div>
  <div>
    <%= form.label "Exercises", style: "display: block" %>

    <%= collection_check_boxes(:routine, :exercise_ids, Exercise.all, :id, :description_with_intensity ) do |m| %>
        <li><%= m.check_box%> - <%= m.label%></li>
    <%end%>
  </div>
  <div>
    <%= form.submit %>
  </div>
<% end %>

app/views/routines/_routine.html.erb
<div id="<%= dom_id routine %>">
  <p>
    <strong>Name:</strong>
    <%= routine.name %>
  </p>

</div>

app/views/routines/edit.html.erb
<h1>Editing routine</h1>

<%= render "form", routine: @routine %>

<br>

<div>
  <%= link_to "Show this routine", @routine %> |
  <%= link_to "Back to routines", routines_path %>
</div>

app/views/routines/index.html.erb
<h1>Routines</h1>

<div id="routines">
  <% @routines.each do |routine| %>
    <%= render routine %>
    <p>
      <%= link_to "Show this routine", routine %>
    </p>
  <% end %>
</div>

<%= link_to "New routine", new_routine_path %>

app/views/routines/new.html.erb
<h1>New routine</h1>

<%= render "form", routine: @routine %>

<br>

<div>
  <%= link_to "Back to routines", routines_path %>
</div>

app/views/routines/show.html.erb
<p style="color: green"><%= notice %></p>

<%= render @routine %>

<h2>Exercises</h2>
<ul>
<% @routine.exercises.each do |exercise| %>
  <li><%= exercise.description_with_intensity %></li>
<%end%>
</ul>


<div>
  <%= link_to "Back to routines", routines_path %>
  <% if  user_signed_in?  %>
  <%= link_to "Edit this routine", edit_routine_path(@routine)  %> 
  <%= button_to "Destroy this routine", @routine, method: :delete %>
  <%end%>
</div>

app/views/users/shared/_error_messages.html.erb
<% if resource.errors.any? %>
  <div id="error_explanation">
    <h2>
      <%= I18n.t("errors.messages.not_saved",
                 count: resource.errors.count,
                 resource: resource.class.model_name.human.downcase)
       %>
    </h2>
    <ul>
      <% resource.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
    </ul>
  </div>
<% end %>

app/views/users/shared/_links.html.erb
<%- if controller_name != 'sessions' %>
  <%= link_to "Log in", new_session_path(resource_name) %><br />
<% end %>

<%- if devise_mapping.registerable? && controller_name != 'registrations' %>
  <%= link_to "Sign up", new_registration_path(resource_name) %><br />
<% end %>

<%- if devise_mapping.recoverable? && controller_name != 'passwords' && controller_name != 'registrations' %>
  <%= link_to "Forgot your password?", new_password_path(resource_name) %><br />
<% end %>

<%- if devise_mapping.confirmable? && controller_name != 'confirmations' %>
  <%= link_to "Didn't receive confirmation instructions?", new_confirmation_path(resource_name) %><br />
<% end %>

<%- if devise_mapping.lockable? && resource_class.unlock_strategy_enabled?(:email) && controller_name != 'unlocks' %>
  <%= link_to "Didn't receive unlock instructions?", new_unlock_path(resource_name) %><br />
<% end %>

<%- if devise_mapping.omniauthable? %>
  <%- resource_class.omniauth_providers.each do |provider| %>
    <%= link_to "Sign in with #{OmniAuth::Utils.camelize(provider)}", omniauth_authorize_path(resource_name, provider), method: :post %><br />
  <% end %>
<% end %>